/*==============================================================*/
/* Storage Template                                             */
/*==============================================================*/

INSERT INTO UI_VIEW_RESOURCE_R
ON EXISTING UPDATE VALUES  ('A_STG_TMPL_AVG_RID');

INSERT INTO UI_VIEW_RESOURCE_R
ON EXISTING UPDATE VALUES  ('B_STG_TMPL_FS_RID');

INSERT INTO UI_VIEW_RESOURCE_R
ON EXISTING UPDATE VALUES  ('C_STG_TMPL_VOL_RID');

INSERT INTO UI_VIEW_RESOURCE_R
ON EXISTING UPDATE VALUES  ('D_STG_TMPL_YES_RID');

INSERT INTO UI_VIEW_RESOURCE_R
ON EXISTING UPDATE VALUES  ('E_STG_TMPL_NO_RID');

INSERT INTO UI_VIEW_ENUM_DEF_R (OBJECT, PROPERTY, VALUE, RESOURCE_ID)
ON EXISTING UPDATE VALUES  ('STG_TMPL', 'TYPE', '0', 'A_STG_TMPL_AVG_RID');

INSERT INTO UI_VIEW_ENUM_DEF_R (OBJECT, PROPERTY, VALUE, RESOURCE_ID)
ON EXISTING UPDATE VALUES  ('STG_TMPL', 'TYPE', '1', 'B_STG_TMPL_FS_RID');

INSERT INTO UI_VIEW_ENUM_DEF_R (OBJECT, PROPERTY, VALUE, RESOURCE_ID)
ON EXISTING UPDATE VALUES  ('STG_TMPL', 'TYPE', '2', 'C_STG_TMPL_VOL_RID');

INSERT INTO UI_VIEW_ENUM_DEF_R (OBJECT, PROPERTY, VALUE, RESOURCE_ID)
ON EXISTING UPDATE VALUES  ('STG_TMPL', 'STATE', '1', 'D_STG_TMPL_YES_RID');

INSERT INTO UI_VIEW_ENUM_DEF_R (OBJECT, PROPERTY, VALUE, RESOURCE_ID)
ON EXISTING UPDATE VALUES  ('STG_TMPL', 'STATE', '0', 'E_STG_TMPL_NO_RID');

/*==============================================================*/
/* View: SF_VIEW_UI_WHOLE_TEMPLATE                   	        */
/*==============================================================*/

IF EXISTS(SELECT 1 FROM SYS.SYSTABLE WHERE TABLE_NAME='SF_VIEW_UI_WHOLE_TEMPLATE' AND TABLE_TYPE='VIEW') THEN
   DROP VIEW SF_VIEW_UI_WHOLE_TEMPLATE
END IF;

CREATE VIEW SF_VIEW_UI_WHOLE_TEMPLATE AS
SELECT
   AVG_TMPL.GUID AS AVG_GUID,
   AVG_TMPL.JSON AS AVG_JSON,
   AVG_TMPL.NAME AS TMPL_NAME,
   FS_TMPL.GUID AS FS_GUID,
   FS_TMPL.JSON AS FS_JSON,
   VOL_TMPL.GUID AS VOL_GUID,
   VOL_TMPL.JSON AS VOL_JSON,
   AVG_TMPL.CREATOR AS CREATOR,
   AVG_TMPL.STATE AS AVG_STATE,
   FS_TMPL.STATE AS FS_STATE,
   VOL_TMPL.STATE AS VOL_STATE,
   AVG_TMPL.PREDEFINED AS AVG_PREDEFINED,
   FS_TMPL.PREDEFINED AS FS_PREDEFINED,
   VOL_TMPL.PREDEFINED AS VOL_PREDEFINED
FROM SF_VIEW_STORAGE_TEMPLATE_R AVG_TMPL
INNER JOIN SF_VIEW_STORAGE_TEMPLATE_R FS_TMPL ON FS_TMPL.PARENT_GUID = AVG_TMPL.GUID
INNER JOIN SF_VIEW_STORAGE_TEMPLATE_R VOL_TMPL ON VOL_TMPL.PARENT_GUID = FS_TMPL.GUID;


GRANT SELECT ON SF_VIEW_UI_WHOLE_TEMPLATE TO HABGUEST;
GRANT DELETE,INSERT,UPDATE,SELECT ON SF_VIEW_UI_WHOLE_TEMPLATE TO HABGUI;
GRANT DELETE,INSERT,UPDATE,SELECT ON SF_VIEW_UI_WHOLE_TEMPLATE TO HABADM;
GRANT DELETE,INSERT,UPDATE,SELECT ON SF_VIEW_UI_WHOLE_TEMPLATE TO HABDBSYNC;


IF EXISTS(SELECT 1 FROM SYS.SYSTABLE WHERE TABLE_NAME='SF_VIEW_UI_STORAGE_TEMPLATE_S' AND TABLE_TYPE='VIEW') THEN
   DROP VIEW SF_VIEW_UI_STORAGE_TEMPLATE_S
END IF;

CREATE VIEW SF_VIEW_UI_STORAGE_TEMPLATE_S AS
SELECT
   TMPL.GUID,
   TMPL.PARENT_GUID,
   TMPL.ID,
   TMPL.NAME,
   TMPL.CREATOR,
   TMPL.TIME_CREATED,
   TMPL.DESCRIPT,
   TMPL.TYPE,
   TMPL.JSON,
   TMPL.PREDEFINED,
   TMPL.STATE,
   RB1.DISPLAY AS DISPLAY_TYPE,
   RB2.DISPLAY AS DISPLAY_PREDEFINED,
   RB3.DISPLAY AS DISPLAY_LOCKED,
   LOCALE.ID AS LOCALE_ID,
   '^'+TMPL.ID+'$^'+TMPL.NAME+'$^'+TMPL.CREATOR+'$^'+TMPL.DESCRIPT AS SEARCH_KEY
FROM SF_VIEW_STORAGE_TEMPLATE_R TMPL
LEFT OUTER JOIN UI_VIEW_SUPP_LOCALE_R LOCALE ON LOCALE.ID IS NOT NULL
LEFT OUTER JOIN UI_VIEW_ENUM_DEF_R ENUM1 ON ENUM1.OBJECT='STG_TMPL' AND ENUM1.PROPERTY='TYPE' AND ENUM1.VALUE=CAST(TYPE AS INT)
LEFT OUTER JOIN UI_VIEW_RES_BUNDLE_R RB1 ON ENUM1.RESOURCE_ID=RB1.ID AND LOCALE.ID = RB1.LOCALE_ID
LEFT OUTER JOIN UI_VIEW_ENUM_DEF_R ENUM2 ON ENUM2.OBJECT='STG_TMPL' AND ENUM2.PROPERTY='STATE' AND ENUM2.VALUE=CAST(PREDEFINED AS INT)
LEFT OUTER JOIN UI_VIEW_RES_BUNDLE_R RB2 ON ENUM2.RESOURCE_ID=RB2.ID AND LOCALE.ID = RB2.LOCALE_ID
LEFT OUTER JOIN UI_VIEW_ENUM_DEF_R ENUM3 ON ENUM3.OBJECT='STG_TMPL' AND ENUM3.PROPERTY='STATE' AND ENUM3.VALUE=CAST(STATE AS INT)
LEFT OUTER JOIN UI_VIEW_RES_BUNDLE_R RB3 ON ENUM3.RESOURCE_ID=RB3.ID AND LOCALE.ID = RB3.LOCALE_ID

GRANT SELECT ON SF_VIEW_UI_STORAGE_TEMPLATE_S TO HABGUEST;
GRANT DELETE,INSERT,UPDATE,SELECT ON SF_VIEW_UI_STORAGE_TEMPLATE_S TO HABGUI;
GRANT DELETE,INSERT,UPDATE,SELECT ON SF_VIEW_UI_STORAGE_TEMPLATE_S TO HABADM;
GRANT DELETE,INSERT,UPDATE,SELECT ON SF_VIEW_UI_STORAGE_TEMPLATE_S TO HABDBSYNC;

COMMIT;


/*==============================================================*/
/* Storage Template                                             */
/*==============================================================*/

INSERT INTO UI_VIEW_RES_BUNDLE_R
ON EXISTING UPDATE VALUES  ('A_STG_TMPL_AVG_RID', 'en_US', 'Application Storage Template');

INSERT INTO UI_VIEW_RES_BUNDLE_R
ON EXISTING UPDATE VALUES  ('B_STG_TMPL_FS_RID', 'en_US', 'File System/Raw');

INSERT INTO UI_VIEW_RES_BUNDLE_R
ON EXISTING UPDATE VALUES  ('C_STG_TMPL_VOL_RID', 'en_US', 'Volume');

INSERT INTO UI_VIEW_RES_BUNDLE_R
ON EXISTING UPDATE VALUES  ('D_STG_TMPL_YES_RID', 'en_US', 'Yes');

INSERT INTO UI_VIEW_RES_BUNDLE_R
ON EXISTING UPDATE VALUES  ('E_STG_TMPL_NO_RID', 'en_US', 'No');

COMMIT;


/*==============================================================*/
/* Storage Template                                             */
/*==============================================================*/

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('A_STG_TMPL_AVG_RID', 'ja_JP', '[欺義 Application Storage Templateeeeeeeeee 拒]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('B_STG_TMPL_FS_RID', 'ja_JP', '[欺義 File System/Rawwwwww 拒]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('C_STG_TMPL_VOL_RID', 'ja_JP', '[欺義 Volumeee 拒]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('D_STG_TMPL_YES_RID', 'ja_JP', '[欺義 Yess 拒]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('E_STG_TMPL_NO_RID', 'ja_JP', '[欺義 Noo 拒]');

COMMIT;


/*==============================================================*/
/* Storage Template                                             */
/*==============================================================*/

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('A_STG_TMPL_AVG_RID', 'zh_CN', '[乗乣 Application Storage Templateeeeeeeeee 倯]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('B_STG_TMPL_FS_RID', 'zh_CN', '[乗乣 File System/Rawwwwww 倯]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('C_STG_TMPL_VOL_RID', 'zh_CN', '[乗乣 Volumeee 倯]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('D_STG_TMPL_YES_RID', 'zh_CN', '[乗乣 Yess 倯]');

-- INSERT INTO UI_VIEW_RES_BUNDLE_R ON EXISTING UPDATE VALUES ('E_STG_TMPL_NO_RID', 'zh_CN', '[乗乣 Noo 倯]');

COMMIT;


