#!/opt/VRTSsfmh/bin/perl



use VRTS::AddOnInfo;
use VRTS::Util;

require File::Path;
require File::Spec;


if ( VRTS::AddOnInfo::is_CS() || VRTS::Util::is_ha_slave()) {
	
	#This is for CS
	my $addon_dir = VRTS::Paths::get_path("DeployStoreDir");

	if ($^O =~ /Win32/i) {
		$addon_dir = $addon_dir."\\VRTSsfmvtp-4.0.1097.0";
	} else {
		$addon_dir = $addon_dir."VRTSsfmvtp-4.0.1097.0";
	}

	my $install_dir = VRTS::Paths::get_path("InstallDir");
	my $mhinstall_dir = File::Spec->canonpath($install_dir);
	my $csinstall_dir = $mhinstall_dir;
	$csinstall_dir =~ s/VRTSsfmh/VRTSsfmcs/;
	my $smdir = File::Spec->catfile($csinstall_dir, "esmweb", "webgui", "sm");
	my $smlibdir = File::Spec->catfile($smdir, "WEB-INF", "lib");
	my $springdir = File::Spec->catfile($smdir, "config", "spring");
    my $helpDir = File::Spec->catdir($csinstall_dir ,"esmweb", "webgui","symhelp","Content","EN_US");
    my @extractedHelpDirs = ("VOMSPADDONCURRENT");


	#Remove the precache file

	my $destdir;

	$destdir = File::Spec->catfile($csinstall_dir, "esmweb", "precache", "web", "VolTmplCache.xml");
	unlink($destdir);


	$destdir = File::Spec->catfile($smdir, "plugins", "voltmpl");
	File::Path::rmtree($destdir);
	
	my $filename;

	$filename = File::Spec->catfile($springdir, "voltmpl-servlet.xml");
	unlink($filename);

	$filename = File::Spec->catfile($springdir, "voltmplmgr-servlet.xml");
	unlink($filename);

	$filename = File::Spec->catfile($smlibdir, "VolTmpl.ext.jar");
	unlink($filename);

	$filename = File::Spec->catfile($smlibdir, "VolTmpl.help.jar");
	unlink($filename);

	$filename = File::Spec->catfile($smlibdir, "VolTmpl.help_ja_JP.jar");
	unlink($filename);
    
    foreach $extDir (@extractedHelpDirs)
    {
       File::Path::rmtree(File::Spec->catdir($helpDir,$extDir));
    }
	print "Storage Provisioning Addon was successfully uninstalled";
	exit(0);

}

print STDERR "Storage Provisioning Addon is not installed on MH";
exit(1);


